<?php

/**
 * reintegro actions.
 *
 * @package    controlComisiones
 * @subpackage reintegro
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class reintegroActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_REINTEGRO', 'COM_PAGO_EGRESO', 'COM_CUENTA_V', 'COM_RESOLUCION', 'COM_COMISION', 'PROYECTOS', 'COM_TERCERO', 'TIPOS_COMISION','TS_TD'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso' => 'COM_REINTEGRO'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'COM_PAGO_EGRESO'
        )
        , 'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'COM_CUENTA_V'
        ),
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
           'id_tipo_comision' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_CUENTA_V'
        ),
        'TS_TD' =>
        array(
            'id_td-id' => 'COM_REINTEGRO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_REINTEGRO' =>
        array(
            'id_reintegro' => 'id_reintegro',
            'id_pago_egreso' => 'id_pago_egreso',
            'id_anhos' => 'id_anhos',
            'fecha_reintegro' => 'fecha_reintegro',
            'valor_total' => 'valor_total',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'observaciones' => 'observaciones',
            'doc_siif' => 'doc_siif',
            'id_td' => 'id_td'
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_cuenta' => 'id_cuenta',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'valor_neto' => 'valor_neto',
        ),
        'COM_CUENTA_V' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'valor' => 'valor'
        ),
        'COM_RESOLUCION' =>
        array(
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos_resol',
            'estado' => 'estado_resol'
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio_comi',
            'fecha_fin' => 'fecha_fin_comi',
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre'
        ),
        'TS_TD' =>
        array(
            'descripcion' => 'tipo_doc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_REINTEGRO' =>
        array(
            'id_reintegro,a' => array('!=' => array(-1)),
            'id_reintegro,b' => array('=' => array('id_reintegro')),
            'id_pago_egreso' => array('=' => array('id_pago_egreso')),
            'id_anhos' => array('=' => array('id_anhos')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_CUENTA_V' =>
        array(
            'id_tercero' => array('=' => array('id_tercero')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_reintegro'; //identificador de la tabla
    protected $id_names = array('id_reintegro'); //llave primaria
    protected $field_names = array('id_pago_egreso', 'id_anhos', 'fecha_reintegro', 'valor_total', 'estado', 'fecha_anulacion', 'motivo_anulacion', 'observaciones','doc_siif','id_td'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_REINTEGRO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_reintegro'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            //Proceso de calculo de ajustes RETENCIONES IVA E ICA
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_pago_egreso = $request['id_pago_egreso'];
        $valor = $request['valor_total'];

        $sql = <<<EOD
SELECT tab0.id_pago_egreso,(tab0.valor_cuenta-tab0.legalizado-tab0.reintegros) as saldo

from(

select tab1.id_pago_egreso,NVL(tab4.valor_cuenta,0) VALOR_CUENTA,NVL(tab2.valor,0) AS LEGALIZADO, NVL(tab3.valor,0)  AS REINTEGROS

from com_pago_egreso tab1 

LEFT JOIN(
select tab0.id_cuenta, sum(tab0.VALOR_CUENTA) VALOR_CUENTA
from COM_DETA_CUENTA tab0
group by tab0.id_cuenta

)tab4 ON tab4.id_cuenta = tab1.id_cuenta


left join(
select tab0.id_pago_egreso, tab0.BRUTO + IVA AS VALOR
from(
select tab0.id_pago_egreso,sum(tab0.vr_bruto)BRUTO,sum(tab0.vr_iva) IVA

from com_registro_gasto tab0
left join pr_elementos_gasto tab1 ON tab1.id_elementos_gasto = tab0.id_elementos_gasto
GROUP BY tab0.id_pago_egreso
)tab0

)tab2 ON tab2.id_pago_egreso = tab1.id_pago_egreso

left join(
select tab1.id_pago_egreso,sum(nvl(tab0.valor_reintegro,0)) AS VALOR
from com_deta_reintegro tab0
join com_reintegro tab1 ON tab1.id_reintegro = tab0.id_reintegro
where tab1.estado = 1
group by tab1.id_pago_egreso
) tab3 ON tab3.id_pago_egreso = tab1.id_pago_egreso

)tab0

where tab0.id_pago_egreso = $id_pago_egreso

EOD;

        $records = CN_TABLE::executeSQL($sql);

        $saldo = $records[0]['saldo'];

        if ($saldo < $valor) {

            $errors['mensaje'] = "No queda saldo para registrar este reintegro. Favor verificar.";
            $errors['servicio'] = "reintegro";
        }

        $sql = <<<EOD
SELECT count(tab0.id_cierre) cantidad

from com_cierre tab0
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Esta comisión ya se encuentra cerrada. No se puede registrar el reintegro";
            $errors['servicio'] = "radicado";
        }

        $sql = <<<EOD
SELECT count(tab0.id_radicado) cantidad

from com_radicado tab0
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad == 0) {

            $errors['mensaje'] = "No existe radicado para esta comisión. No se puede registrar el reintegro";
            $errors['servicio'] = "radicado";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_reintegro = $request['id_reintegro'];

        $sql = <<<EOD
SELECT id_pago_egreso from com_reintegro where id_reintegro = $id_reintegro
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_pago_egreso = $records[0]['id_pago_egreso'];


        $sql = <<<EOD
SELECT count(tab0.id_cierre) cantidad

from com_cierre tab0
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Esta comisión ya se encuentra cerrada. No se puede anular el reintegro";
            $errors['servicio'] = "radicado";
        }

        return $errors;
    }

}
